(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/common'), require('@angular/core'), require('@angular/forms'), require('@angular/cdk/coercion'), require('@angular/material/core')) :
    typeof define === 'function' && define.amd ? define('@nutrify/ngx-simple-spinner', ['exports', '@angular/common', '@angular/core', '@angular/forms', '@angular/cdk/coercion', '@angular/material/core'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global.nutrify = global.nutrify || {}, global.nutrify['ngx-simple-spinner'] = {}), global.ng.common, global.ng.core, global.ng.forms, global.ng.cdk.coercion, global.ng.material.core));
}(this, (function (exports, common, i0, forms, coercion, core) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    /** @deprecated */
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    /** @deprecated */
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    function __spreadArray(to, from) {
        for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
            to[j] = from[i];
        return to;
    }
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }
    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    Number.prototype.toFixedNoRounding = function (fractionDigits) {
        if (fractionDigits === void 0) { fractionDigits = 0; }
        var valueStr = this.toString();
        var commaIndex = valueStr.indexOf('.');
        if (commaIndex !== -1) {
            return +valueStr.substr(0, commaIndex + fractionDigits + 1);
        }
        return this;
    };
    var Round;
    (function (Round) {
        Round[Round["up"] = 0] = "up";
        Round[Round["down"] = 1] = "down";
    })(Round || (Round = {}));
    var SimpleDecimal = /** @class */ (function () {
        function SimpleDecimal(maxDecimalPlaces, value) {
            if (value === void 0) { value = null; }
            this._maxDecimalPlacesFn = maxDecimalPlaces instanceof Function ? maxDecimalPlaces : function () { return maxDecimalPlaces; };
            this.value = value;
        }
        Object.defineProperty(SimpleDecimal.prototype, "integerPart", {
            get: function () {
                if (this._integerPart == null) {
                    var valueStr = this.toString();
                    var commaIndex = valueStr.indexOf('.');
                    var integerPart = +valueStr.substr(0, commaIndex);
                    if (commaIndex !== -1) {
                        this._integerPart = integerPart;
                    }
                    else {
                        this._integerPart = this.value;
                    }
                }
                return this._integerPart;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SimpleDecimal.prototype, "decimalPart", {
            get: function () {
                var valueStr = this.toString();
                var commaIndex = valueStr.indexOf('.');
                if (commaIndex !== -1) {
                    if (this.value >= 0) {
                        return +('0.' + valueStr.substr(commaIndex + 1, this.maxDecimalPlaces));
                    }
                    return -('0.' + valueStr.substr(commaIndex + 1, this.maxDecimalPlaces));
                }
                return 0;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SimpleDecimal.prototype, "dividend", {
            get: function () {
                this.calculateFraction();
                return this._dividend;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SimpleDecimal.prototype, "divisor", {
            get: function () {
                this.calculateFraction();
                return this._divisor;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SimpleDecimal.prototype, "decimalPlaces", {
            get: function () {
                var valueStr = this.toString();
                var commaIndex = valueStr.indexOf('.');
                return commaIndex !== -1 ? valueStr.length - commaIndex : 0;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SimpleDecimal.prototype, "value", {
            get: function () {
                return this._value;
            },
            set: function (value) {
                this._value = null;
                if (value != null) {
                    this._value = +Number(value).toFixedNoRounding(this.maxDecimalPlaces);
                }
                this._integerPart = null;
                this._dividend = null;
                this._divisor = null;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SimpleDecimal.prototype, "maxDecimalPlaces", {
            get: function () {
                return this._maxDecimalPlacesFn();
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SimpleDecimal.prototype, "hasPrettyFraction", {
            get: function () {
                if (this.dividend && this.divisor) {
                    return true;
                }
                return false;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SimpleDecimal.prototype, "precedingStr", {
            get: function () {
                var integerPart = this.integerPart;
                return '' + (integerPart !== 0 ? integerPart : (this.value < 0 ? '-' : ''));
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SimpleDecimal.prototype, "dividendStr", {
            get: function () {
                return '' + this.dividend;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SimpleDecimal.prototype, "divisorStr", {
            get: function () {
                return '' + this.divisor;
            },
            enumerable: false,
            configurable: true
        });
        SimpleDecimal.prototype.toString = function () {
            if (this.value != null) {
                return String(this.value).replace(',', '.');
            }
            else {
                return '';
            }
        };
        SimpleDecimal.prototype.add = function (i) {
            this.value += i;
            return this;
        };
        SimpleDecimal.prototype.sub = function (i) {
            this.value -= i;
            return this;
        };
        SimpleDecimal.prototype.toNearest = function (multiple, roundMode) {
            if (roundMode === void 0) { roundMode = Round.up; }
            multiple = +multiple.toFixed(this.maxDecimalPlaces);
            if (multiple > 0 && this.value != null) {
                var quotient = +(this.decimalPart / multiple).toFixed(this.maxDecimalPlaces);
                switch (roundMode) {
                    case Round.down:
                        quotient = Math.ceil(quotient) - 1;
                        break;
                    default:
                        quotient = Math.floor(quotient) + 1;
                        break;
                }
                return +(this.integerPart + (multiple * quotient)).toFixed(this.maxDecimalPlaces);
            }
            return this.value;
        };
        SimpleDecimal.prototype.calculateFraction = function () {
            if (this.maxDecimalPlaces >= 2 && !(this._dividend && this._divisor)) {
                var decimalPart = Math.abs(this.decimalPart);
                if (decimalPart) {
                    switch (decimalPart) {
                        case (1 / 4).toFixedNoRounding(this.maxDecimalPlaces):
                            this._dividend = 1;
                            this._divisor = 4;
                            break;
                        case (1 / 3).toFixedNoRounding(this.maxDecimalPlaces):
                            this._dividend = 1;
                            this._divisor = 3;
                            break;
                        case (1 / 2).toFixedNoRounding(this.maxDecimalPlaces):
                            this._dividend = 1;
                            this._divisor = 2;
                            break;
                        case (2 / 3).toFixedNoRounding(this.maxDecimalPlaces):
                        case +(2 / 3).toFixed(this.maxDecimalPlaces):
                            this._dividend = 2;
                            this._divisor = 3;
                            break;
                        case (3 / 4).toFixedNoRounding(this.maxDecimalPlaces):
                            this._dividend = 3;
                            this._divisor = 4;
                            break;
                    }
                }
            }
        };
        return SimpleDecimal;
    }());

    var Direction;
    (function (Direction) {
        Direction[Direction["default"] = 0] = "default";
        Direction[Direction["leftToRight"] = 1] = "leftToRight";
        Direction[Direction["rightToLeft"] = 2] = "rightToLeft";
    })(Direction || (Direction = {}));

    var DeviceService = /** @class */ (function () {
        function DeviceService() {
            this.mobileOrTablet = false;
            this.mobileOrTablet = this.isMobileOrTablet();
        }
        DeviceService.prototype.isMobileOrTablet = function () {
            var check = false;
            (function (a) {
                // eslint-disable-next-line max-len
                if (/(android|bb\d+|meego).+mobile|avantgo|bada\/|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od)|iris|kindle|lge |maemo|midp|mmp|mobile.+firefox|netfront|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\/|plucker|pocket|psp|series(4|6)0|symbian|treo|up\.(browser|link)|vodafone|wap|windows ce|xda|xiino|android|ipad|playbook|silk/i.test(a) || /1207|6310|6590|3gso|4thp|50[1-6]i|770s|802s|a wa|abac|ac(er|oo|s\-)|ai(ko|rn)|al(av|ca|co)|amoi|an(ex|ny|yw)|aptu|ar(ch|go)|as(te|us)|attw|au(di|\-m|r |s )|avan|be(ck|ll|nq)|bi(lb|rd)|bl(ac|az)|br(e|v)w|bumb|bw\-(n|u)|c55\/|capi|ccwa|cdm\-|cell|chtm|cldc|cmd\-|co(mp|nd)|craw|da(it|ll|ng)|dbte|dc\-s|devi|dica|dmob|do(c|p)o|ds(12|\-d)|el(49|ai)|em(l2|ul)|er(ic|k0)|esl8|ez([4-7]0|os|wa|ze)|fetc|fly(\-|_)|g1 u|g560|gene|gf\-5|g\-mo|go(\.w|od)|gr(ad|un)|haie|hcit|hd\-(m|p|t)|hei\-|hi(pt|ta)|hp( i|ip)|hs\-c|ht(c(\-| |_|a|g|p|s|t)|tp)|hu(aw|tc)|i\-(20|go|ma)|i230|iac( |\-|\/)|ibro|idea|ig01|ikom|im1k|inno|ipaq|iris|ja(t|v)a|jbro|jemu|jigs|kddi|keji|kgt( |\/)|klon|kpt |kwc\-|kyo(c|k)|le(no|xi)|lg( g|\/(k|l|u)|50|54|\-[a-w])|libw|lynx|m1\-w|m3ga|m50\/|ma(te|ui|xo)|mc(01|21|ca)|m\-cr|me(rc|ri)|mi(o8|oa|ts)|mmef|mo(01|02|bi|de|do|t(\-| |o|v)|zz)|mt(50|p1|v )|mwbp|mywa|n10[0-2]|n20[2-3]|n30(0|2)|n50(0|2|5)|n7(0(0|1)|10)|ne((c|m)\-|on|tf|wf|wg|wt)|nok(6|i)|nzph|o2im|op(ti|wv)|oran|owg1|p800|pan(a|d|t)|pdxg|pg(13|\-([1-8]|c))|phil|pire|pl(ay|uc)|pn\-2|po(ck|rt|se)|prox|psio|pt\-g|qa\-a|qc(07|12|21|32|60|\-[2-7]|i\-)|qtek|r380|r600|raks|rim9|ro(ve|zo)|s55\/|sa(ge|ma|mm|ms|ny|va)|sc(01|h\-|oo|p\-)|sdk\/|se(c(\-|0|1)|47|mc|nd|ri)|sgh\-|shar|sie(\-|m)|sk\-0|sl(45|id)|sm(al|ar|b3|it|t5)|so(ft|ny)|sp(01|h\-|v\-|v )|sy(01|mb)|t2(18|50)|t6(00|10|18)|ta(gt|lk)|tcl\-|tdg\-|tel(i|m)|tim\-|t\-mo|to(pl|sh)|ts(70|m\-|m3|m5)|tx\-9|up(\.b|g1|si)|utst|v400|v750|veri|vi(rg|te)|vk(40|5[0-3]|\-v)|vm40|voda|vulc|vx(52|53|60|61|70|80|81|83|85|98)|w3c(\-| )|webc|whit|wi(g |nc|nw)|wmlb|wonu|x700|yas\-|your|zeto|zte\-/i.test(a.substr(0, 4))) {
                    check = true;
                }
                // eslint-disable-next-line @typescript-eslint/dot-notation
            })(navigator.userAgent || navigator.vendor || window['opera']);
            return check;
        };
        return DeviceService;
    }());
    DeviceService.ɵprov = i0.ɵɵdefineInjectable({ factory: function DeviceService_Factory() { return new DeviceService(); }, token: DeviceService, providedIn: "root" });
    DeviceService.decorators = [
        { type: i0.Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    DeviceService.ctorParameters = function () { return []; };

    var LanguageService = /** @class */ (function () {
        function LanguageService() {
        }
        Object.defineProperty(LanguageService.prototype, "preferredLanguage", {
            get: function () {
                var e_1, _a, e_2, _b;
                if (this._language !== undefined) {
                    return this._language;
                }
                var nav = window.navigator;
                var browserLanguagePropertyKeys = ['language', 'browserLanguage', 'systemLanguage', 'userLanguage'];
                // support for HTML 5.1 "navigator.languages"
                if (nav.languages instanceof Array) {
                    try {
                        for (var _c = __values(nav.languages), _d = _c.next(); !_d.done; _d = _c.next()) {
                            var language = _d.value;
                            if (language && language.length) {
                                return this._language = String(language).substring(0, 2).toLowerCase();
                            }
                        }
                    }
                    catch (e_1_1) { e_1 = { error: e_1_1 }; }
                    finally {
                        try {
                            if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
                        }
                        finally { if (e_1) throw e_1.error; }
                    }
                }
                try {
                    // support for other well known properties in browsers
                    for (var browserLanguagePropertyKeys_1 = __values(browserLanguagePropertyKeys), browserLanguagePropertyKeys_1_1 = browserLanguagePropertyKeys_1.next(); !browserLanguagePropertyKeys_1_1.done; browserLanguagePropertyKeys_1_1 = browserLanguagePropertyKeys_1.next()) {
                        var prop = browserLanguagePropertyKeys_1_1.value;
                        var language = nav[prop];
                        if (language && language.length) {
                            return this._language = String(language).substring(0, 2).toLowerCase();
                        }
                    }
                }
                catch (e_2_1) { e_2 = { error: e_2_1 }; }
                finally {
                    try {
                        if (browserLanguagePropertyKeys_1_1 && !browserLanguagePropertyKeys_1_1.done && (_b = browserLanguagePropertyKeys_1.return)) _b.call(browserLanguagePropertyKeys_1);
                    }
                    finally { if (e_2) throw e_2.error; }
                }
                return this._language = null;
            },
            enumerable: false,
            configurable: true
        });
        LanguageService.prototype.isRTLpreferred = function () {
            if (this._isRTLpreferred !== undefined) {
                return this._isRTLpreferred;
            }
            switch (this.preferredLanguage) {
                case 'ar':
                case 'dv':
                case 'fa':
                case 'ha':
                case 'he':
                case 'ks':
                case 'ku':
                case 'ms':
                case 'ps':
                case 'sd':
                case 'tg':
                case 'ug':
                case 'ur':
                case 'uz':
                case 'yi':
                    return this._isRTLpreferred = true;
                default:
                    return this._isRTLpreferred = false;
            }
        };
        return LanguageService;
    }());
    LanguageService.ɵprov = i0.ɵɵdefineInjectable({ factory: function LanguageService_Factory() { return new LanguageService(); }, token: LanguageService, providedIn: "root" });
    LanguageService.decorators = [
        { type: i0.Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];

    var SpinnerKeyManager = /** @class */ (function () {
        function SpinnerKeyManager(spinner) {
            this.spinner = spinner;
        }
        SpinnerKeyManager.prototype.catchKey = function (event) {
            var key = event.key;
            if (key) {
                switch (key) {
                    case 'ArrowUp':
                        this.spinner.add(true);
                        break;
                    case 'ArrowDown':
                        this.spinner.subtract(true);
                        break;
                    default:
                        return;
                }
                // Prevent only for keys, because of a firefox css :active bug on buttons
                event.preventDefault();
            }
        };
        return SpinnerKeyManager;
    }());

    var nextUniqueId = 0;
    var BUFFER_TIMEOUT = 250;
    var TIMEOUT = 50;
    var SimpleSpinnerBase = /** @class */ (function () {
        function SimpleSpinnerBase(_elementRef, _defaultErrorStateMatcher, _parentForm, _parentFormGroup, ngControl) {
            this._elementRef = _elementRef;
            this._defaultErrorStateMatcher = _defaultErrorStateMatcher;
            this._parentForm = _parentForm;
            this._parentFormGroup = _parentFormGroup;
            this.ngControl = ngControl;
        }
        return SimpleSpinnerBase;
    }());
    // eslint-disable-next-line @typescript-eslint/naming-convention
    var _SimpleSpinnerMixinBase = core.mixinTabIndex(core.mixinDisabled(core.mixinErrorState(SimpleSpinnerBase)));
    var SpinnerComponent = /** @class */ (function (_super) {
        __extends(SpinnerComponent, _super);
        function SpinnerComponent(device, elementRef, _defaultErrorStateMatcher, _parentForm, _parentFormGroup, ngControl, tabIndex, cdRef, langService) {
            var _this = _super.call(this, elementRef, _defaultErrorStateMatcher, _parentForm, _parentFormGroup, ngControl) || this;
            _this.device = device;
            _this.ngControl = ngControl;
            _this.cdRef = cdRef;
            _this.langService = langService;
            _this.hover = false;
            _this.focus = false;
            _this.intervalHandler = null;
            // Regex allows all numerals (0-9, Arabic, Hindi, Thai, ...) and commas
            // eslint-disable-next-line max-len
            _this.filterKeyRegex = /^[0-9\u0660-\u0669\u06F0-\u06F9\u0966-\u096F\u0A66-\u0A6F\u0AE6-\u0AEF\u0B66-\u0B6F\u09E6-\u09EF\u0BE6-\u0BEF\u0C66-\u0C6F\u0CE6-\u0CEF\u0D66-\u0D6F\u0DE6-\u0DEF\u1040-\u1049\u17E0-\u17E9\u0E50-\u0E59\u0ED0-\u0ED9\u1810-\u1819\u0F20-\u0F29.,\-]+$/;
            // Enum for usage in template
            // eslint-disable-next-line @typescript-eslint/naming-convention
            _this.Direction = Direction;
            _this._min = Number.MIN_SAFE_INTEGER;
            _this._max = Number.MAX_SAFE_INTEGER;
            _this._hoverBorder = false;
            _this._hoverNav = true;
            _this._fractions = false;
            _this._i18nNumbers = true;
            _this._bigStep = 1;
            _this._smallStep = 1;
            _this._maxDecimalPlaces = 0;
            _this._required = false;
            _this.uid = "simple-spinner-" + ++nextUniqueId;
            _this.propagateChange = function (_) { };
            _this.propagateTouched = function () { };
            if (_this.ngControl) {
                // Note: we provide the value accessor through here, instead of
                // the `providers` to avoid running into a circular import.
                // It has to be done this way also, to be able to access the errorState.
                _this.ngControl.valueAccessor = _this;
            }
            _this.decimal = new SimpleDecimal(function () { return _this.maxDecimalPlaces; });
            _this.keyManager = new SpinnerKeyManager(_this);
            _this.tabIndex = parseInt(tabIndex, 10) || 0;
            // Force setter to be called in case id was not specified.
            _this.id = _this.id;
            return _this;
        }
        Object.defineProperty(SpinnerComponent.prototype, "id", {
            get: function () { return this._id; },
            set: function (id) {
                this._id = id || this.uid;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SpinnerComponent.prototype, "value", {
            get: function () { return this.decimal.value; },
            set: function (value) {
                this.decimal.value = value;
                // Return the decimal value instead of value, to propagate the rounded value
                this.propagateChange(this.decimal.value);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SpinnerComponent.prototype, "min", {
            get: function () { return this._min; },
            set: function (min) {
                if (min != null) {
                    min = parseFloat(min);
                    if (!isNaN(min)) {
                        this._min = Math.min(Math.max(min, Number.MIN_SAFE_INTEGER), Number.MAX_SAFE_INTEGER);
                    }
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SpinnerComponent.prototype, "max", {
            get: function () { return this._max; },
            set: function (max) {
                if (max != null) {
                    max = parseFloat(max);
                    if (!isNaN(max)) {
                        this._max = Math.min(Math.max(max, Number.MIN_SAFE_INTEGER), Number.MAX_SAFE_INTEGER);
                    }
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SpinnerComponent.prototype, "hoverBorder", {
            get: function () { return this._hoverBorder; },
            set: function (hoverBorder) {
                this._hoverBorder = coercion.coerceBooleanProperty(hoverBorder);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SpinnerComponent.prototype, "hoverNav", {
            get: function () { return this._hoverNav; },
            set: function (hoverNav) {
                this._hoverNav = coercion.coerceBooleanProperty(hoverNav);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SpinnerComponent.prototype, "fractions", {
            get: function () { return this._fractions; },
            set: function (fractions) {
                this._fractions = coercion.coerceBooleanProperty(fractions);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SpinnerComponent.prototype, "i18nNumbers", {
            get: function () { return this._i18nNumbers; },
            set: function (i18nNumbers) {
                this._i18nNumbers = coercion.coerceBooleanProperty(i18nNumbers);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SpinnerComponent.prototype, "bigStep", {
            get: function () { return this._bigStep; },
            set: function (bigStep) {
                bigStep = coercion.coerceNumberProperty(bigStep);
                this._bigStep = Math.min(Math.max(bigStep, Number.MIN_SAFE_INTEGER), Number.MAX_SAFE_INTEGER);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SpinnerComponent.prototype, "smallStep", {
            get: function () { return this._smallStep; },
            set: function (smallStep) {
                smallStep = coercion.coerceNumberProperty(smallStep);
                this._smallStep = Math.min(Math.max(smallStep, Number.MIN_SAFE_INTEGER), Number.MAX_SAFE_INTEGER);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SpinnerComponent.prototype, "maxDecimalPlaces", {
            get: function () { return this._maxDecimalPlaces; },
            set: function (maxDecimalPlaces) {
                this._maxDecimalPlaces = coercion.coerceNumberProperty(maxDecimalPlaces);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SpinnerComponent.prototype, "required", {
            get: function () { return this._required; },
            set: function (required) {
                this._required = coercion.coerceBooleanProperty(required);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SpinnerComponent.prototype, "direction", {
            get: function () {
                switch (this.dir) {
                    case 'ltr':
                        return Direction.leftToRight;
                    case 'rtl':
                        return Direction.rightToLeft;
                    case 'auto':
                        return this.langService.isRTLpreferred() ? Direction.rightToLeft : Direction.leftToRight;
                    default:
                        return Direction.default;
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SpinnerComponent.prototype, "showBorder", {
            get: function () {
                // Always show the border if disabled or focused
                return this.disabled || this.focus || this.errorState || !this.hoverBorder || this.hoverBorder && this.hover;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SpinnerComponent.prototype, "showNav", {
            get: function () {
                // Always show the navigation if disabled or focused
                // Never show on mobile
                return !this.device.mobileOrTablet && (this.disabled || this.focus || !this.hoverNav || this.hoverNav && this.hover);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SpinnerComponent.prototype, "showFractionOverlay", {
            get: function () {
                return this.decimal.hasPrettyFraction && this.fractions && !this.focus && (this.disabled || !this.hover);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SpinnerComponent.prototype, "showPlaceholder", {
            get: function () {
                return this.decimal.value == null && this.placeholder != null && !this.focus;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SpinnerComponent.prototype, "ariaLabel", {
            get: function () {
                return this._ariaLabel || this.placeholder;
            },
            enumerable: false,
            configurable: true
        });
        SpinnerComponent.prototype.checkValue = function () {
            // This has to be done over the ElementRef because Angular won't emit a change if the value stays the same
            // Also the value should only be submitted after blur
            var value = parseFloat(this.numberInput.nativeElement.value);
            this.value = isNaN(value) ? null : Math.min(Math.max(value, this.min), this.max);
            this.numberInput.nativeElement.value = this.value;
        };
        SpinnerComponent.prototype.filterKey = function (event) {
            if (!event.ctrlKey &&
                !event.metaKey &&
                !event.altKey &&
                event.code !== '' && // On Chrome for Android the code is empty
                event.key !== event.code &&
                !event.key.match(this.filterKeyRegex)) {
                event.preventDefault();
            }
        };
        SpinnerComponent.prototype.increment = function () {
            // Special logic for increment only, in case the value is null / undefined
            // It does not get more readable :(
            if (this.decimal.value == null) {
                if (this.min === Number.MIN_SAFE_INTEGER) {
                    this.decimal.value = Math.min(this.max, this.bigStep);
                }
                else if (this.max === Number.MAX_SAFE_INTEGER) {
                    this.decimal.value = Math.max(this.min, this.bigStep);
                }
                else {
                    this.decimal.value = Math.min(this.max, this.bigStep);
                }
                this.propagateChange(this.decimal.value);
                this.cdRef.markForCheck();
                return;
            }
            // This might happen if the user sets the value lower than the min (same behaviour in Chrome)
            if (this.decimal.value < this.min) {
                this.decimal.value = this.min;
                this.propagateChange(this.decimal.value);
                this.cdRef.markForCheck();
                return;
            }
            if (this.decimal.value < this.max) {
                // If an integer and less or equal to max - 1
                if (this.decimal.decimalPlaces === 0 && this.decimal.value <= (this.max - this.bigStep)) {
                    this.decimal.value += this.bigStep; // add
                }
                else { // Float value or greater than max - 1
                    // Next closest value plus step: 0.6 -> 0.75 -> 1 ...
                    var stepValue = this.decimal.toNearest(this.smallStep, Round.up);
                    // If less or equal to max then set the value to the new stepValue
                    if (stepValue <= this.max) {
                        this.decimal.value = stepValue;
                    }
                    else {
                        this.decimal.value = this.max;
                    }
                }
                this.propagateChange(this.decimal.value);
                this.cdRef.markForCheck();
            }
            else {
                // Select value if max was reached
                this.numberInput.nativeElement.select();
            }
        };
        SpinnerComponent.prototype.decrement = function () {
            // Special logic for decrement only, in case the value is null / undefined
            // It does not get more readable :(
            if (this.decimal.value == null) {
                if (this.max === Number.MAX_SAFE_INTEGER) {
                    this.decimal.value = Math.max(this.min, -this.bigStep);
                }
                else if (this.min === Number.MIN_SAFE_INTEGER) {
                    this.decimal.value = Math.min(this.max, -this.bigStep);
                }
                else {
                    this.decimal.value = Math.max(this.min, -this.bigStep);
                }
                this.propagateChange(this.decimal.value);
                this.cdRef.markForCheck();
                return;
            }
            // This might happen if the user sets the value higher than the max (same behaviour in Chrome)
            if (this.decimal.value > this.max) {
                this.decimal.value = this.max;
                this.propagateChange(this.decimal.value);
                this.cdRef.markForCheck();
                return;
            }
            if (this.decimal.value > this.min) {
                // If an integer and greater or equal than min + 1
                if (this.decimal.decimalPlaces === 0 && this.decimal.value >= (this.min + this.bigStep)) {
                    this.decimal.value -= this.bigStep; // subtract
                }
                else { // Float value or smaller than min + 1
                    // Next closest value minus step: 0.6 -> 0.5 -> 0.25 ...
                    var stepValue = this.decimal.toNearest(this.smallStep, Round.down);
                    // If greater or equal to min then set the value to the new stepValue
                    if (stepValue >= this.min) {
                        this.decimal.value = stepValue;
                    }
                    else {
                        this.decimal.value = this.min;
                    }
                }
                this.propagateChange(this.decimal.value);
                this.cdRef.markForCheck();
            }
            else {
                // Select value if min was reached
                this.numberInput.nativeElement.select();
            }
        };
        SpinnerComponent.prototype.add = function (once) {
            var _this = this;
            if (once) {
                this.increment();
            }
            else {
                this.startCount(function () { return _this.increment(); });
            }
        };
        SpinnerComponent.prototype.subtract = function (once) {
            var _this = this;
            if (once) {
                this.decrement();
            }
            else {
                this.startCount(function () { return _this.decrement(); });
            }
        };
        SpinnerComponent.prototype.startCount = function (callback) {
            var _this = this;
            callback();
            this.intervalHandler = setTimeout(function () {
                _this.intervalHandler = setInterval(function () {
                    callback();
                }, TIMEOUT);
            }, BUFFER_TIMEOUT);
        };
        SpinnerComponent.prototype.stopCount = function () {
            if (this.intervalHandler) {
                clearInterval(this.intervalHandler);
                this.intervalHandler = null;
            }
        };
        SpinnerComponent.prototype.mouseenter = function () {
            this.hover = true;
        };
        SpinnerComponent.prototype.mouseleave = function () {
            this.hover = false;
        };
        SpinnerComponent.prototype.focusInput = function () {
            this.focus = true;
        };
        SpinnerComponent.prototype.changeInput = function () {
            this.propagateTouched();
        };
        SpinnerComponent.prototype.blurInput = function () {
            this.checkValue();
            this.focus = false;
        };
        SpinnerComponent.prototype.writeValue = function (value) {
            this.value = value;
        };
        SpinnerComponent.prototype.registerOnChange = function (fn) {
            this.propagateChange = fn;
        };
        SpinnerComponent.prototype.registerOnTouched = function (fn) {
            this.propagateTouched = fn;
        };
        SpinnerComponent.prototype.setDisabledState = function (isDisabled) {
            this.disabled = isDisabled;
        };
        SpinnerComponent.prototype.ngDoCheck = function () {
            if (this.ngControl) {
                this.updateErrorState();
            }
        };
        return SpinnerComponent;
    }(_SimpleSpinnerMixinBase));
    SpinnerComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'simple-spinner',
                    exportAs: 'simpleSpinner',
                    template: "<div [ngClass]=\"{\r\n    'simple-spinner-border': showBorder,\r\n    'simple-spinner-invalid': errorState,\r\n    'simple-spinner-rtl': direction === Direction.rightToLeft,\r\n    'simple-spinner-ltr': direction === Direction.leftToRight\r\n  }\" class=\"simple-spinner-wrapper\" (mouseenter)=\"mouseenter()\" (mouseleave)=\"mouseleave()\">\r\n  <div class=\"simple-spinner-input-wrapper\">\r\n    <div *ngIf=\"showPlaceholder\" class=\"simple-spinner-placeholder\">\r\n      <span>{{placeholder}}</span>\r\n    </div>\r\n    <div [ngClass]=\"{'simple-spinner-inactive': showFractionOverlay}\" class=\"simple-spinner-input\">\r\n      <input #numberInput type=\"number\" tabindex=\"{{tabIndex}}\"\r\n        [value]=\"value\"\r\n        (change)=\"changeInput()\"\r\n        (keydown)=\"filterKey($event)\"\r\n        (focus)=\"focusInput()\"\r\n        (blur)=\"blurInput()\"\r\n        step=\"any\"\r\n        autocomplete=\"off\"\r\n        [disabled]=\"disabled\">\r\n    </div>\r\n    <div *ngIf=\"showFractionOverlay\" class=\"simple-spinner-fraction-overlay\">\r\n      <span dir=\"ltr\">{{decimal.precedingStr | i18nNumber:i18nNumbers}}\r\n        <sup dir=\"ltr\">{{decimal.dividend | i18nNumber:i18nNumbers}}</sup>&frasl;<sub dir=\"ltr\">{{decimal.divisor | i18nNumber:i18nNumbers}}</sub>\r\n      </span>\r\n    </div>\r\n  </div>\r\n  <div *ngIf=\"showNav\" class=\"simple-spinner-nav\">\r\n    <button [disabled]=\"disabled\" class=\"simple-spinner-arrow simple-spinner-arrow-up\" (mousedown)=\"add()\" (mouseup)=\"stopCount()\" (mouseleave)=\"stopCount()\" tabindex=\"-1\"></button>\r\n    <button [disabled]=\"disabled\" class=\"simple-spinner-arrow simple-spinner-arrow-down\" (mousedown)=\"subtract()\" (mouseup)=\"stopCount()\" (mouseleave)=\"stopCount()\" tabindex=\"-1\"></button>\r\n  </div>\r\n</div>\r\n",
                    inputs: ['disabled', 'tabIndex'],
                    encapsulation: i0.ViewEncapsulation.None,
                    changeDetection: i0.ChangeDetectionStrategy.OnPush,
                    host: {
                        '[attr.id]': 'id',
                        class: 'simple-spinner',
                        role: 'input',
                        '[attr.aria-label]': 'ariaLabel',
                        '[attr.aria-required]': 'required.toString()',
                        '[attr.aria-disabled]': 'disabled.toString()',
                        '[attr.aria-invalid]': 'errorState',
                        '[class.simple-disabled]': 'disabled',
                        '[class.simple-required]': 'required',
                        '(keydown)': '!disabled && keyManager.catchKey($event)'
                    }
                },] }
    ];
    SpinnerComponent.ctorParameters = function () { return [
        { type: DeviceService },
        { type: i0.ElementRef },
        { type: core.ErrorStateMatcher },
        { type: forms.NgForm, decorators: [{ type: i0.Optional }] },
        { type: forms.FormGroupDirective, decorators: [{ type: i0.Optional }] },
        { type: forms.NgControl, decorators: [{ type: i0.Self }, { type: i0.Optional }] },
        { type: String, decorators: [{ type: i0.Attribute, args: ['tabindex',] }] },
        { type: i0.ChangeDetectorRef },
        { type: LanguageService }
    ]; };
    SpinnerComponent.propDecorators = {
        placeholder: [{ type: i0.Input }],
        dir: [{ type: i0.Input }],
        errorStateMatcher: [{ type: i0.Input }],
        _ariaLabel: [{ type: i0.Input, args: ['aria-label',] }],
        id: [{ type: i0.Input }],
        value: [{ type: i0.Input }],
        min: [{ type: i0.Input }],
        max: [{ type: i0.Input }],
        hoverBorder: [{ type: i0.Input }],
        hoverNav: [{ type: i0.Input }],
        fractions: [{ type: i0.Input }],
        i18nNumbers: [{ type: i0.Input }],
        bigStep: [{ type: i0.Input }],
        smallStep: [{ type: i0.Input }],
        maxDecimalPlaces: [{ type: i0.Input }],
        required: [{ type: i0.Input }],
        numberInput: [{ type: i0.ViewChild, args: ['numberInput', { static: true },] }]
    };

    var InternationalNumberPipe = /** @class */ (function () {
        function InternationalNumberPipe(langService) {
            switch (langService.preferredLanguage) {
                // Arabic-Indic
                case 'ar': // Arabic
                    this._offset = 1584;
                    break;
                // Eastern Arabic-Indic
                case 'fa': // Persian
                case 'ur': // Urdu
                    this._offset = 1728;
                    break;
                // Ignore Hindi, Thai, ... numerals, since they are rarely used
            }
        }
        InternationalNumberPipe.prototype.transform = function (num, apply) {
            if (apply === void 0) { apply = true; }
            var numStr = String(num);
            // Condition whether or not to apply the transformation
            if (!apply) {
                return numStr;
            }
            /*
            European             U+0030..U+0039   0123456789
            Arabic-Indic         U+0660..U+0669   ٠١٢٣٤٥٦٧٨٩
            Eastern Arabic-Indic U+06F0..U+06F9   äÒÚÛÙıˆ˜¯˘
            */
            if (this._offset === undefined) {
                return numStr;
            }
            var transformedNumStr = '';
            // eslint-disable-next-line @typescript-eslint/prefer-for-of
            for (var i = 0; i < numStr.length; i++) {
                var charCode = numStr.charCodeAt(i);
                if (charCode < 48 || charCode > 57) {
                    transformedNumStr += numStr[i];
                    continue;
                }
                transformedNumStr += String.fromCharCode(charCode + this._offset);
            }
            return transformedNumStr;
        };
        return InternationalNumberPipe;
    }());
    InternationalNumberPipe.decorators = [
        { type: i0.Pipe, args: [{ name: 'i18nNumber' },] }
    ];
    InternationalNumberPipe.ctorParameters = function () { return [
        { type: LanguageService }
    ]; };

    var SimpleSpinnerModule = /** @class */ (function () {
        function SimpleSpinnerModule() {
        }
        return SimpleSpinnerModule;
    }());
    SimpleSpinnerModule.decorators = [
        { type: i0.NgModule, args: [{
                    declarations: [SpinnerComponent, InternationalNumberPipe],
                    imports: [
                        common.CommonModule,
                        forms.FormsModule
                    ],
                    providers: [
                        DeviceService
                    ],
                    exports: [SpinnerComponent, forms.FormsModule, InternationalNumberPipe]
                },] }
    ];

    /*
     * Public API Surface of simple-spinner
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.SimpleSpinnerModule = SimpleSpinnerModule;
    exports.SpinnerComponent = SpinnerComponent;
    exports.ɵa = DeviceService;
    exports.ɵb = LanguageService;
    exports.ɵc = InternationalNumberPipe;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=nutrify-ngx-simple-spinner.umd.js.map
